/*
 * epub.c - Milena Audiobook Creator
 * Copyright (C) Bohdan R. Rau 2009 <ethanak@polip.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write see:
 *               <http://www.gnu.org/licenses/>.
 */
#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <epub.h>
#include "html.h"

append_xhtml(char *c,char **outb)
{
    int n=html2txt(c,NULL);
    char *s;
    if (n<=0) return;
    if (!*outb) {
        *outb=malloc(n+1);
        s=*outb;
    }
    else {
        *outb=realloc(*outb,strlen(*outb)+n);
        s=*outb+strlen(*outb);
    }
    html2txt(c,s);
}

char *read_epub(char *name,char **err)
{
    struct epub *epub;
    struct eiterator *it;
    char *outht=NULL;
    epub=epub_open(name, 0);
    if (!epub) {
        if (err) *err="Błąd otwarcia pliku ePub";
        epub_cleanup();
        return NULL;
    }
    //it=epub_get_iterator(epub, EITERATOR_SPINE, 0);
    it=epub_get_iterator(epub, EITERATOR_LINEAR, 0);
    do {
        char *c=epub_it_get_curr(it);
        if (c) append_xhtml(c,&outht);
    } while (epub_it_get_next(it));
    epub_free_iterator(it);
    epub_close(epub);
    if (!outht) {
        if (err) *err="Pusta treść ePub";
    }
    return outht;
}
